%define debug_package %{nil}

Name:			exfat-utils
Summary:		Utilities for exFAT file system
Version:		1.3.0
Release:		1%{?dist}
License:		GPLv3+
Group:			System Environment/Base
Source0:		http://exfat.googlecode.com/files/exfat-utils-%{version}.tar.gz
Patch1:			%{name}-%{version}-patch-001
URL:			https://github.com/relan/exfat
BuildRoot:		%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:		automake fuse-devel
BuildRequires:		gzip
Obsoletes:		fuse-exfat

%description
A set of utilities for creating, checking, dumping and labeling exFAT file
system.

%prep
%setup -q
%if  0%{?centos} == 5 || 0%{?centos} == 6
%patch1 -p1
%endif

%build
autoreconf --install
%configure
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%make_install
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8/
gzip -9 -c dump/dumpexfat.8 > $RPM_BUILD_ROOT%{_mandir}/man8/dumpexfat.8.gz
gzip -9 -c fsck/exfatfsck.8 > $RPM_BUILD_ROOT%{_mandir}/man8/exfatfsck.8.gz
ln -s %{_mandir}/man8/exfatfsck.8.gz $RPM_BUILD_ROOT%{_mandir}/man8/fsck.exfat.8.gz
gzip -9 -c mkfs/mkexfatfs.8 > $RPM_BUILD_ROOT%{_mandir}/man8/mkexfatfs.8.gz
ln -s %{_mandir}/man8/mkexfatfs.8.gz $RPM_BUILD_ROOT%{_mandir}/man8/mkfs.exfat.8.gz
gzip -9 -c label/exfatlabel.8 > $RPM_BUILD_ROOT%{_mandir}/man8/exfatlabel.8.gz
gzip -9 -c fuse/mount.exfat-fuse.8 > $RPM_BUILD_ROOT%{_mandir}/man8/mount.exfat-fuse.8.gz
ln -s %{_mandir}/man8/mount.exfat-fuse.8.gz $RPM_BUILD_ROOT%{_mandir}/man8/mount.exfat.8.gz

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%attr(755,root,root)	%{_sbindir}/dumpexfat
%attr(755,root,root)	%{_sbindir}/exfatfsck
%attr(755,root,root)	%{_sbindir}/exfatlabel
			%{_sbindir}/fsck.exfat
%attr(755,root,root)	%{_sbindir}/mkexfatfs
			%{_sbindir}/mkfs.exfat
			%{_sbindir}/mount.exfat
%attr(755,root,root)	%{_sbindir}/mount.exfat-fuse
%attr(644,root,root)	%{_mandir}/man8/dumpexfat.8.gz
%attr(644,root,root)	%{_mandir}/man8/exfatfsck.8.gz
%attr(644,root,root)	%{_mandir}/man8/exfatlabel.8.gz
			%{_mandir}/man8/fsck.exfat.8.gz
%attr(644,root,root)	%{_mandir}/man8/mkexfatfs.8.gz
			%{_mandir}/man8/mkfs.exfat.8.gz
%attr(644,root,root)	%{_mandir}/man8/mount.exfat-fuse.8.gz
%attr(644,root,root)	%{_mandir}/man8/mount.exfat.8.gz

%changelog
* Sat Sep 15 2018 Lawrence R. Rogers <lrr@cert.org> - 1.3.0-1
* Release 1.3.0-1
	1.3.0-1 (2018-09-15)
		* exfatfsck can now repair some errors.
		* Added experimental Android support for exfat-utils [liminghao, LongPingWEI,
		  Pablo Mendez Hernandez, Pierre-Hugues Husson].
		* Cleaned up FUSE code preparing for FUSE 3 support.
		* Removed OpenBSD support as it does not handle -o option in fuse_main().
		* Re-introduced FreeBSD support [Oleksii Samorukov].
		* Fixed DragonFly BSD support [Tomohiro Kusumi].
		* dirent->d_type in now filled on readdir() [Mark Browning].

* Sat Feb  3 2018 Lawrence R. Rogers <lrr@cert.org> - 1.2.8-1
* Release 1.2.8-1
	1.2.8 (2018-02-03)
		* Fixed new files or directories creation in the root directory: ensure there
		  are no 0x00 entries before valid ones; otherwise Windows can corrupt them.
		* Fixed compilation on GNU/HURD platform.

* Mon Jun  5 2017 Lawrence R. Rogers <lrr@cert.org> - 1.2.7-1
* Release 1.2.7-1
	1.2.7 (2017-06-05)
		* Fixed handling of two last clusters: operations with files that occupy these
		  clusters could fail.
		* Fixed crash when started with stdin, stdout or stderr closed.

	1.2.6 (2017-01-28)
		* Operations with directories (except initial listing) now make less
		  read/write system calls.
		* Fixed handling of files with optional tail entries (0xe0-0xff): videoclip
		  files created by Sony cameras were missing.
		* Write operations now correctly return ENOSPC (instead of EIO) when there is
		  no free disk space left.
		* Fixed max file name length: it's 255 16-bit code units (not 256).

	1.2.5 (2016-12-05)
		* Added an option for dumpexfat to show file fragments [Daniel Drake].
		* Fixed crash when directory starts with an invalid cluster.
		* Daylight saving time in now properly reflected in file timestamps.

* Fri Jun  3 2016 Lawrence R. Rogers <lrr@cert.org> - 1.2.4-1
* Release 1.2.4-1
	* Fixed wrong files names hashes when upper case table is compressed.
	* Man pages are now installed by default.
	* Commas and backslashes in device names are now escaped.

* Sat Dec 19 2015 Lawrence R. Rogers <lrr@cert.org> - 1.2.3-1
* Release 1.2.3-1
	1.2.3 (2015-12-19)
	* Fixed clusters loss when file renaming replaces target.

	1.2.2 (2015-11-09)
	* Improved reliability in case of a sudden unplug: FS will be in a clean state
	  after closing all files and performing sync(1).
	* Fixed compilation on Debian GNU/kFreeBSD and GNU/Hurd platforms.
	* Updated mount.exfat-fuse man page.

	1.2.1 (2015-09-24)
	* Fixed compatibility with Zalman VE-200: now newly created directories do not
	  have archive bit set.
	* Fixed heap corruption: malformed FS can use invalid sector or cluster size.
	* Fixed hang on mount: malformed FS can have cyclic references in the clusters
	  map.

* Wed Aug 26 2015 Lawrence R. Rogers <lrr@cert.org> - 1.2.0-1
* Release 1.2.0-1
    1.2.0 (2015-08-26)
	* Switched from SCons to autotools.
	* Added musl libc support [Brendan Heading].
	* Worked around "FS is larger than device" error for memory cards formatted by Panasonic Lumix cameras.
	* Worked around "unknown entry type 0xe1" error for memory cards formatted by Sony cameras.

    1.1.1 (2014-11-15)
	* Fixed mkfs crash on some sectors-per-cluster (-s option) values.

    1.1.0 (2014-07-08)

	* Relicensed the project from GPLv3+ to GPLv2+.
	* OpenBSD support [Helg Bredow].
	* Improved I/O errors handling.
	* Implemented fsync() and fsyncdir().
	* Fixed crash on Mac OS X 10.5 caused by non-standard use of realpath(). Also
	  fixed TrueCrypt disks unmounting.
	* Avoid extra erase on writes to the end of a file. This should improve linear write speed.
	* Allow arbitrary changing of lower 9 bits of mode. Allow owner/group changing
	  to the same owner/group. This fixes rsync.
	* Fixed buffers overflows when handling lengthy file names.
	* Fixed "real size does not equal to size" error on volumes with pagefile.sys.
	* Fixed negative IUsed in "df -i" output.

* Sat Feb 02 2013 Lawrence R. Rogers <lrr@cert.org> - 1.0.1-1
* Release 1.0.1-1
	* Fixed unexpected removal of a directory if it is moved into itself.
	* Fixed "Operation not permitted" error on reading an empty file.

* Sat Jan 19 2013 Lawrence R. Rogers <lrr@cert.org> - 1.0.0-1
* Release 1.0.0-1

	* Fixed crash when renaming a file within a single directory and a new name differs only in case.
	* Fixed clusters allocation: a cluster beyond valid clusters range could be allocated.
	* Fixed crash when a volume is unmounted while some files are open.
	* SConscript now respects AR and RANLIB environment variables.
	* Improved error handling.

	Linux:

	* Enabled big_writes. This improves write speed (larger block size means less switches between kernel- and user-space).
	* Do BLKROGET ioctl to make sure the device is not read-only: after "blockdev --setro" kernel still allows to open the device
	  in read-write mode but fails writes.

	OS X:

	* Fixed OS X 10.8 support.
	* Switched to 64-bit inode numbers (now Mac OS X 10.5 or later is required).
	* Switched from unmaintained MacFUSE to OSXFUSE (http://osxfuse.github.com).
	* Fixed device size detection. Now mkfs works.
	* Workarounded some utilities failures due to missing chmod() support.
	* Disabled (senseless) permission checks made by FUSE.

* Thu Aug  9 2012 Andrew Nayenko <resver@gmail.com> - 0.9.8-1
- Updated to 0.9.8.

* Thu Mar  8 2012 Andrew Nayenko <resver@gmail.com> - 0.9.7-1
- Updated to 0.9.7.

* Sat Jan 14 2012 Andrew Nayenko <resver@gmail.com> - 0.9.6-1
- Updated to 0.9.6.
- Added symlinks to the man pages (fsck.exfat.8, mkfs.exfat.8).

* Sun May 15 2011 Andrew Nayenko <resver@gmail.com> - 0.9.5-1
- Updated to 0.9.5.

* Sat Mar  5 2011 Andrew Nayenko <resver@gmail.com> - 0.9.4-1
- Initial package for Fedora.
